// Automatic injection of XHC properties

DefinitionBlock ("", "SSDT", 2, "T460", "XHC", 0)
{
    /*External(\_SB.PCI0.XHC, DeviceObj)

    // inject properties for XHCI
        Method(\_SB.PCI0.XHC._DSM, 4)
        {
            If (!Arg2) { Return (Buffer() { 0x03 } ) }
            Local0 = Package()
            {
                "AAPL,current-available", Buffer() { 0x34, 0x08, 0, 0 },
                "AAPL,current-extra", Buffer() { 0x98, 0x08, 0, 0, },
                "AAPL,current-extra-in-sleep", Buffer() { 0x40, 0x06, 0, 0, },
                "AAPL,max-port-current-in-sleep", Buffer() { 0x34, 0x08, 0, 0 },
            }
            Return(Local0)
        }
    */

    Device(_SB.USBX)
    {
        Name(_ADR, 0)
        Method (_DSM, 4)
        {
            If (!Arg2) { Return (Buffer() { 0x03 } ) }
            Return (Package()
            {
                // these values from MacBookPro14,3
                "kUSBSleepPortCurrentLimit", 3000,
                "kUSBWakePortCurrentLimit", 3000,
            })
        }
    }
// USBInjectAll configuration/override for Lenovo T460
// Override for USBInjectAll.kext - if UIAC exists, use it instead
    Device(UIAC)
    {
        Name(_HID, "UIA00000")
        Name(RMCF, Package()
        {
            // XHC overrides
            "8086_9d2f", Package()
             {
                "port-count", Buffer() { 18, 0, 0, 0 },
                "ports", Package()
                {
                    "HS01", Package() // HS USB3 left side
                    {
                        "UsbConnector", 3,
                        "port", Buffer() { 1, 0, 0, 0 },
                    },
                    "HS02", Package() // HS USB3 right side far
                    {
                        "UsbConnector", 3,
                        "port", Buffer() { 2, 0, 0, 0 },
                    },
//                    "HS03", Package()
//                    {
//                        "UsbConnector", 3,
//                        "port", Buffer() { 3, 0, 0, 0 },
//                    },
                    "HS04", Package() // HS USB3 right side near
                    {
                        "UsbConnector", 3,
                        "port", Buffer() { 4, 0, 0, 0 },
                    },
//                    "HS05", Package()
//                    {
//                        "UsbConnector", 3,
//                        "port", Buffer() { 5, 0, 0, 0 },
//                    },
//                    "HS06", Package()
//                    {
//                        "UsbConnector", 3,
//                        "port", Buffer() { 6, 0, 0, 0 },
//                    },
                    "HS07", Package() // Bluetooth
                    {
                        "UsbConnector", 255,
                        "port", Buffer() { 7, 0, 0, 0 },
                    },
                    "HS08", Package() // Webcam
                    {
                        "UsbConnector", 255,
                        "port", Buffer() { 8, 0, 0, 0 },
                    },
//                    "HS09", Package()
//                    {
//                        "UsbConnector", 3,
//                        "port", Buffer() { 9, 0, 0, 0 },
//                    },
//                    "HS10", Package()
//                    {
//                        "UsbConnector", 3,
//                        "port", Buffer() { 10, 0, 0, 0 },
//                    },
                    "SS01", Package() // SS USB3 left side
                    {
                        "UsbConnector", 3,
                        "port", Buffer() { 13, 0, 0, 0 },
                    },
                    "SS02", Package() // SS USB3 right side far
                    {
                        "UsbConnector", 3,
                        "port", Buffer() { 14, 0, 0, 0 },
                    },
                    "SS03", Package() // SS SD card reader
                    {
                        "UsbConnector", 255,
                        "port", Buffer() { 15, 0, 0, 0 },
                    },
                    "SS04", Package() // SS USB 3 right side near
                    {
                        "UsbConnector", 3,
                        "port", Buffer() { 16, 0, 0, 0 },
                    },
//                    "SS05", Package()
//                    {
//                        "UsbConnector", 3,
//                        "port", Buffer() { 17, 0, 0, 0 },
//                    },
//                    "SS06", Package()
//                    {
//                        "UsbConnector", 3,
//                        "port", Buffer() { 18, 0, 0, 0 },
//                    },
//                    "USR1", Package()
//                    {
//                        "UsbConnector", 3,
//                        "port", Buffer() { 11, 0, 0, 0 },
//                    },
//                    "USR2", Package()
//                    {
//                        "UsbConnector", 3,
//                        "port", Buffer() { 12, 0, 0, 0 },
//                    },
                },
            },

        })
    }
}

//EOF
